#include "monster.h"

Monster* new_monster() {
	
	Monster* new = (Monster*) g_malloc(sizeof(Monster));

	new->name = g_string_new("new monster");
	new->x = 0;
	new->y = 0;
	new->width = 0;
	new->height = 0;
	new->facing = UP;
	new->state = (0x0000);
	new->sprite_cur = 0;
	new->properties = (0x0000);
	new->race = NEW_MONSTER;
	new->access = (0x0000);
	new->agression = 0;
	new->weight = 0;
	new->behaviour = NULL;
	new->max_ap = 0;
	new->cur_ap = 0;
	new->max_hp = 1;
	new->cur_hp = 1;
	new->armor = 0;
	new->attacks = g_ptr_array_new();
	new->attack_cnt = 0;
	new->attack_cur = 0;
	new->initiative = 0;
	new->initiative_adj = 0;
	new->inventory = g_ptr_array_new();
	new->inventory_mask = (0x0000);

}

void zap_monster(Monster* monster) {

	gint i;

	if(monster != NULL) {

		if(monster->name != NULL) {
			
			g_string_free(monster->name,TRUE);
			monster->name = NULL;
		
		}

		if(monster->attacks != NULL) {

			for(i=0;i<monster->attack_cnt;i++)
				zap_attack(g_ptr_array_index(monster->attacks,i));
			g_ptr_array_free(monster->attacks,FALSE);
			monster->attacks = NULL;
			
		}

		if(monster->inventory != NULL) {

			g_ptr_array_free(monster->inventory,FALSE);
			monster->inventory = NULL;
			
		}

		g_free(monster);
		monster = NULL;

	}

}

Attack* new_attack() {

	Attack* new = (Attack*) g_malloc(sizeof(Attack));

	new->tohit = 0;
	new->min_dmg = 0;
	new->max_dmg = 0;
	new->ap_cost = 0;

	return new;
	
}

void zap_attack(Attack* attack) {
	
	if(attack != NULL) {

		g_free(attack);
		attack = NULL;

	}

}
